
##  Versión automática tipo maximizar


    ## Asignamos los coeficientes en la función objetivo (puede haber varios objetivos)
    ## y añadimos los vectores correspondentes a las variables de holgura y/o artificiales a 
    ## la matriz A

ch=matrix(QQ,1,0,[] )
ct=matrix(QQ,1,0,[] )

ccx=matrix(QQ,1,0,[] )
cct=matrix(QQ,1,0,[] )
Cero=matrix(QQ,1,1,[0] )
Uno=matrix(QQ,1,1,[1] )


FASEI=var('FI', latex_name='\\ \\ \\ Fase\\ I')
FASEII=var('FII', latex_name='\\ \\ \\ Fase\\ II')

salto=var('salto', latex_name='')
raya=var('ry', latex_name='===================================')
dual=var('dual', latex_name='\\texttt{El dual es:}')


##############################################################################
####### Usando el paquete de programación lineal Pinteractive de Sage ########
##############################################################################
signos=[]
for i in range(m):
    if h[0,i] == -1:
        signos.append(">=")
    elif h[0,i] == 1:
        signos.append("<=")
    elif h[0,i] == 0:
        signos.append("==")
        
var_nam = []
for i in range(n):
    k=i+1
    var_nam.append('x_%s' %k)
        
PPL = InteractiveLPProblem(A, b, c, var_nam,   
constraint_type=signos, variable_type=">=", problem_type=tipo) 

##############################################################################

show(ry)
show(ry)
show(PPL)
show(PPL.optimal_value())
show(PPL.optimal_solution())
show(ry)
show(ry)
dual=var('dual', latex_name='\\texttt{El dual es:}')

show(salto)

show(dual)
show(ry)
show(PPL.dual())
show(ry)
show(PPL.dual().optimal_value())
show(PPL.dual().optimal_solution())

show(salto)
show(ry)


B=var('B', latex_name='Basic')
rhs = var('rhs', latex_name='b')
rhs1 = var('rhs1', latex_name='b_1')
rhs2 = var('rhs2', latex_name='b_2')
rhs3 = var('rhs3', latex_name='b_3')
B = matrix(SR,1,1, B)  
rhs = matrix(SR,1,1, rhs) 

Z=var('Z', latex_name='Z_{ind}')
Z = matrix(SR,1,1, Z)
Z1p=var('Z1p', latex_name='Z{1p}')
Z1p = matrix(SR,1,1, Z1p)
Z2p=var('Z2p', latex_name='Z{2p}')
Z2p = matrix(SR,1,1, Z2p)
Z3p=var('Z3p', latex_name='Z{3p}')
Z3p = matrix(SR,1,1, Z3p)

W = var('W', latex_name='W_{ind}')
W = matrix(SR,1,1, W) 

 
#### Analicemos las variables artificiales que hay en el problema  ######

I=matrix.identity(QQ,m)
BM1=I

xi = var('x', n=n+3, latex_name="x"); #xi._latex_()
X = matrix(SR, xi)
XX = X[0,[1 .. (n)]]  

si = var('s', n=5*m+1, latex_name="\\color{green}{s}"); #xi._latex_()
S = matrix(SR, si)
SS = S[0,[1 .. (m)]]

ti = var('t', n=m+1, latex_name="\\color{red}{t}") 
T = matrix(SR, ti)
TT = T[0,[1 .. (m)]]


    
for i in range(n):
    ccx=block_matrix([ [ccx, Cero ] ])

nv=n;
tt=[];
idpos=n-1;
colbas=[0 .. (m-1)]

signos=[]
IS=matrix(QQ,m,0,[])
e=0  # Eliminemos las variables introducidas en SS que no son variables de holgura
for i in range(m):
    if h[0,i] == -1:
        IS=block_matrix([ [ IS,-I[:,i] ]])
        ch=block_matrix([ [ch, Cero ] ])
        tt.append(1)
        idpos=idpos+1
        nv=nv+1
        signos.append(">=")
    elif h[0,i] == 1:
        IS=block_matrix([[IS,I[:,i]]])
        ch=block_matrix([[ch, Cero ]])
        colbas[i]=idpos+1
        idpos=idpos+1
        tt.append(0)
        nv=nv+1
        signos.append("<=")
    elif h[0,i] == 0:
        tt.append(1)
        signos.append("==")
        i=i-e
        SS=SS[[0],[0 .. i-1,i+1 .. m-1-e]]
        e=e+1 


t=matrix(ZZ,1,m,tt);    


nvar=nv

###28oct###

#e=0  # Eliminemos las variables introducidas en SS que no son variables de holgura
#for i in range(m):
#    if h[0,i] == 0:
#        i=i-e
#        SS=SS[[0],[0 .. i-1,i+1 .. m-1-e]]
#        e=e+1 
    

e=0
nart=0 # Será el número de variables artificiales en el problema
## Eliminemos las variables introducidas en TT que no son variables artificiales.
## Agregamos a la matriz A los vectores columnas de las variables artificiales
## Terminamos de crear el vector con las posiciones de las variables básicas originales (holgura + artificiales)

IA=matrix(QQ,m,0,[])
for i in range(m):
  if t[0,i] == 0:
     i=i-e
     TT=TT[[0],[0 .. i-1,i+1 .. m-1-e]]
     e=e+1
  elif t[0,i] == 1:
     IA=block_matrix([[IA,I[:,i]]])
     ct=block_matrix([[ct, Cero ]])
     cct=block_matrix([[cct, Uno ]])
     nv=nv+1
     nart=nart+1
     colbas[i]=idpos+1
     idpos=idpos+1

A=block_matrix([[A,IS,IA]])


if nart > 0:
    Art=1
elif nart == 0:
    Art=0
        
cols=[i for i in range(nv)]    #columnas en la matriz A 


#vars=block_matrix([ [XX,SS,TT] ])  # nombres de todas las variables


cv=block_matrix([ [c,ch,ct] ])
ccv=block_matrix([ [ccx,ch,cct] ])

boriginal=b    
Aoriginal=A

def cuadro(m,n): 
    global A,b,varsB,vars,colbas,Cuadro,zb,w,cv, ccv ,cbar, ccbar, cB  ,ccB  #,P,BM1
  
    if Art==1:
        vars=block_matrix([ [XX,SS,TT] ])  # nombres de todas las variables

        #cv=block_matrix([ [c,ch,ct] ])
        #ccv=block_matrix([ [ccx,ch,cct] ])
                
        #cB=cv[:, colbas ] 
        #cbar=cv-cB*A

        ccB=ccv[:,colbas]
        
        ccbar=ccv-ccB*A
        
                
        #zb=cB*b
        w=ccB*b 
                
        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)  
        
        Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[W,ccbar,w] ] )   
        show(FASEI)
        show(ry)
        show(Cuadro)
    if Art==0: 
           
        vars=block_matrix([ [XX,SS] ])  # nombres de todas las variables
        cv=block_matrix([ [c,ch] ])
        cB=cv[:, colbas ] 
        cbar=cv-cB*A
        zb=cB*b
        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)
        
        Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b], [Z,cbar,zb] ] )   
        show(Cuadro)    
        
        

    return


cuadro(m,n);         

## nnArt es el número de variables artificiales en la base al final de la fase I
## L es un vector con la posición de dichas variables señaladas con un 1

def faseII(nnArt,L): 
    global A,b,varsB,vars,P,cols,colbas,ccv,cv,cB,Cuadro,nart,Aoriginal,Aoriginalold,Art,zb,w,cbar,ccbar,nv, BM1,Z
    
    if nnArt==0: 
           
        nv=nv-nart
        cols=[i for i in range(nv)] #[cols[0,0], .. cols[0,nv-1-nart] ] 
        vars=block_matrix([ [XX,SS] ])  # nombres de todas las variables
        A=A[:,cols]
        
        Art=0
        cv=block_matrix([ [c,ch] ])
        cB=cv[:, colbas ] 
        cbar=cv-cB*A
        zb=cB*b
        
        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)
        
        Cuadro=block_matrix([ [B,vars,rhs], [varsB,A,b], [Z,cbar,zb] ] )       
        show(ry)
        show(FASEII)
        show(ry)
        #show(Cuadro)
    
    if nnArt!=0:
           
        nv=nv-nart
        cols=[i for i in range(nv)]  #[cols[0,0], .. cols[0,nv-1-nart] ] 
        vars=block_matrix([ [XX,SS] ])  # nombres de todas las variables
        A=A[:,cols]
        ee=0
        for i in range(m):
             if L[i]==1:
                del colbas[i-ee]
                A=A[[0..i-1-ee,i+1-ee..m-1-ee],:]
                b=b[[0..i-1-ee,i+1-ee..m-1-ee],:]
                BM1=BM1[[0..i-1-ee,i+1-ee..m-1-ee],[0..i-1-ee,i+1-ee..m-1-ee]]
                Aoriginalold=Aoriginal
                Aoriginal=Aoriginal[[0..i-1-ee,i+1-ee..m-1-ee],:]
                ee=ee+1
        Art=0
        cv=block_matrix([ [c,ch] ])
        
        cB=cv[:, colbas ] 
                
        cbar=cv-cB*A
                
        zb=cB*b
        
        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)

        Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )   
        show(ry)
        show(FASEII)
        show(ry)
        #show(Cuadro)   
    return

def cocientes(k):
    global A, b
    v=matrix(RR,len(A.column(0)),1,0)
    v=matrix(SR,v)   
    for i in range(len(A.column(0))):
        if A[i,k-1]<=0:
           v[i,:]='NO'
        else:
           v[i,:]= N(b[i]/A[i,k-1],digits=5) 
    return v

def cocientesA(k):
    global A, b
    vs=-1
    v=infinity
    for i in range(len(A.column(0))):
        if A[i,k-1]>0:
            vv=b[i]/A[i,k-1]
            if vv[0][0]< v:
                v=vv[0][0]
                vs=i
    return vs
    
def cocientesD(l):
    global A,cbar
    v=matrix(RR,1,len(cbar.row(0)),0)
    v=matrix(SR,v)
    for j in range(len(cbar.row(0))):
        if A[l-1,j]>=0:
            v[:,j]='NO'
        else:
            v[:,j]= N(cbar[0,j]/A[l-1,j],digits=5)   
    return v


def pivot(l,k):
    global A, BM1
    P=matrix.identity(QQ,len(A.column(0)))
    for i in range(len(A.column(0))):
        if i==l-1:
            P[i,l-1]=1/A[l-1,k-1] 
        else:
            P[i,l-1]=-A[i,k-1]/A[l-1,k-1]
    BM1=P*BM1
    return P

def cambio(l,k):
    global A,b,B,varsB,vars,P,Cuadro,Art,cv,ch,ccv,cols,colbas,cbar,zb,w,cB,ccbar
    
    if Art==1:
      P=pivot(l,k) 
      A=P*A
      b=P*b
     
      colbas[l-1]=cols[k-1]
      
      cB=cv[:, colbas ] 
      ccB=ccv[:,colbas]
             
      cbar=cv-cB*A
      ccbar=ccv-ccB*A
      
      
      zb=cB*b
      
      w=ccB*b 

      varsB=vars[:,colbas]
      varsB=column_matrix(SR,varsB) 
      
      Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[W,ccbar,w] ] ) 
      
      show(Cuadro)
    
    if Art==0:
        P=pivot(l,k) 
        A=P*A
        b=P*b
        
        colbas[l-1]=cols[k-1]
      
        cB=cv[:, colbas ] 
        
        cbar=cv-cB*A

        zb=cB*b
        
        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)
        
        Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )  
       
        show(Cuadro) 
    return
    
def cambioA(l,k):
    global A,b,B,Z,W,varsB,vars,P,Cuadro,Art,cv,ch,ccv,cols,colbas,cbar,zb,w,cB,rhs,ccbar
    
    if Art==1:
      P=pivot(l,k) 
      A=P*A
      b=P*b
      
      colbas[l-1]=cols[k-1]
      
      cB=cv[:, colbas ] 
      ccB=ccv[:,colbas]
       
      cbar=cv-cB*A
      ccbar=ccv-ccB*A
      
      zb=cB*b
      
      w=ccB*b 

      varsB=vars[:,colbas]
      varsB=column_matrix(SR,varsB) 
      
      Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[W,ccbar,w] ] )  
   
      
      #show(Cuadro)
    
    if Art==0:
        P=pivot(l,k) 
        A=P*A
        b=P*b
        
        colbas[l-1]=cols[k-1]
      
        cB=cv[:, colbas ] 
        
        cbar=cv-cB*A

        zb=cB*b
        
        Z=var('Z', latex_name='Z_{ind}')
        Z = matrix(SR,1,1, Z)
        W = var('W', latex_name='W_{ind}')
        W = matrix(SR,1,1, W) 

        varsB=vars[:,colbas]
        varsB=column_matrix(SR,varsB)
        
        Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )  
       
        #show(Cuadro) 
    return 



def Bm(L):
    global Aoriginal, nnArt
    L=[L[i]-1 for i in range(m-nnArt) ]
    Bmatriz=Aoriginal[:,L]
    return Bmatriz   
   
def añadeRes(v,R):
    global A, Aoriginal, boriginal, b,cB,c,cbar, m, n, vars, varsB, B, Z,zb,rhs,Cuadro, BM1, cols, colbas, cv,  nv,S, J
    #show(colbas)
    vB=v[:,colbas]
    #show(vB)
    vB_BM1= -vB*BM1 
    BM11=block_matrix([[BM1],[vB_BM1]])
    vdeide=matrix.identity(m+1)[:,m];
    BM1=block_matrix([[BM11,vdeide]], subdivide=false)
    
    bsig=vB_BM1*boriginal+R
    #print(bsig)
    b=block_matrix([[b],[bsig]],subdivide=false); #vector de la derecha
    RR=matrix(QQ,1,1,[R])
    boriginal=block_matrix([[boriginal],[RR]],subdivide=false); #vector de la derecha original con el añadido
    #show(boriginal)
    #show(vB)
    #show(A)
    #show(v)
    vN=-vB*A+v
    #show(vB*A)
    A=block_matrix([[A],[vN]], subdivide=false);
    A=block_matrix([[A,vdeide]], subdivide=false);
    cols.append(nv)
    colbas.append(nv)
    
    #show(colbas)
    
    zo=matrix(QQ,1,1,[0])
    cv=block_matrix([[cv,zo]])
    cB=cv[:, colbas ] 
    cbar=cv-cB*A
    #show(cB)
    
    vars=block_matrix([[vars, S[0,m+1]]], subdivide=false)
    varsB=vars[:,colbas]
    varsB=column_matrix(SR,varsB)
    
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )   
    
    m=m+1
    nv=nv+1
    J.append(nv)
    show(Cuadro)
    #show(cocientesD(nv-2))
    return

J=[1..nv]
def corte(k):
    global fl, J
    show(J)
    #show(v)
    kk=k-1
    vv=[1..nv]
    #show(b[kk][0])
    fl=b[kk][0] - floor(b[kk][0])
    ffl=fl/(fl-1)
    #show(fl)
    #show(ffl)
    
    for i in range(nv):
        #show(A[kk,i])
        if (A[kk,i] in ZZ) and (i+1 in J):
            vv[i]=0
            #show(vv)
        else: 
            fki=A[kk,i]-floor(A[kk,i])
            if (i+1 not in J) and (A[kk,i]<0):
                vv[i]=A[kk,i]*ffl
                #show(vv)
            if (i+1 not in J) and (A[kk,i]>=0):
                vv[i]=A[kk,i]
                #show(vv)
            if (i+1 in J):
                vv[i]=min(fki,(fki-1)*ffl)
                #show(vv)
    #show(vv)
    
    #show(v)
    denominadores=[f.denominator() for f in vv]
    dencom=lcm(denominadores)
    vv=[f.numerator()*(dencom//f.denominator()) for f in vv]
    v=matrix(QQ,1,nv,vv )
    añadeRes(-v,-fl*dencom)
    return

def pardec():
    global J
    pardec=[1..m]
    show(J)
    for kk in range(m):
        pardec[kk]=b[kk][0] - floor(b[kk][0])

    return pardec

def añadeVar(An1,cn1):
    global A, Aoriginal, boriginal, b,cB,c, cbar,m, n, vars, varsB, B, Z,zb,rhs,Cuadro, BM1, cols, colbas, cv, nv,S

    An1N=BM1*An1  # Vector columna de la nueva variable en el cuadro óptimo

    cv=block_matrix([[cv,cn1]], subdivide=false) # Se añade el costo de la nueva variable al vector de costos

    cbarn1=cn1-cB*An1N  # Elemento de la nueva variable en la fila indicadora de dicho cuadro

    A=block_matrix([[A,An1N]], subdivide=false) # Nueva matriz A

    cbar=block_matrix([[cbar,cbarn1]], subdivide=false) # Nueva fila indicadora

    vars=block_matrix([[vars, X[0,n+1]]],subdivide=false) # Nuevo vector de variables

    nv=nv+1 # Número de variables actual
    cols.append(nv)   # Nueva columna
    
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )       
    show(Cuadro)  
    return
def param1b(b1p):
    global A,b,varsB,rhs,rhs1,cbar,zb, Cuadro
    b1=BM1*b1p;zb1=cB*b1
    b=block_matrix([ [b, b1] ] , subdivide=False)
    rhs=block_matrix([[rhs,rhs1]], subdivide=False)
    zb=block_matrix([[zb,zb1]], subdivide=False)
    Cuadro=block_matrix([[B,vars,rhs],[varsB,A,b],[Z,cbar,zb] ] )
    show(Cuadro)
    
def param2b(b1p,b2p):
    global A,b,varsB,rhs,rhs1,cbar,zb, Cuadro
    b1=BM1*b1p;zb1=cB*b1
    b2=BM1*b2p;zb2=cB*b2
    b=block_matrix([ [b, b1, b2] ] , subdivide=False)
    rhs=block_matrix([[rhs,rhs1,rhs2]], subdivide=False)
    zb=block_matrix([[zb,zb1,zb2]], subdivide=False)
    Cuadro=block_matrix([[B,vars,rhs],[varsB,A,b],[Z,cbar,zb] ] )
    show(Cuadro)

def param1c(c1p):
    global A,b,varsB,rhs,cbar,zb, Cuadro, c1bar, z1b, cB, cv,Z1p, colbas,Z
    c1v=block_matrix([[c1p,ch]])
    cv=block_matrix([[cv], [c1v] ])
    cB=cv[:,colbas]
    cbar=cv-cB*A
    zb=cB*b
    Z=block_matrix([[Z],[Z1p]])
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )   
    show(Cuadro)
    
def param2c(c1p,c2p):
    global A,b,varsB,rhs,cbar,zb, Cuadro, c1bar, z1b, cB, cv,Z1p, colbas,Z
    c1v=block_matrix([[c1p,ch]])
    c2v=block_matrix([[c2p,ch]])    
    cv=block_matrix([[cv], [c1v], [c2v] ])
    cB=cv[:,colbas]
    cbar=cv-cB*A
    zb=cB*b
    Z=block_matrix([[Z],[Z1p],[Z2p]])
    Cuadro=block_matrix([[B,vars,rhs] , [varsB,A,b],[Z,cbar,zb] ] )   
    show(Cuadro)
    
############################################################################################
############################################################################################

if tipo == 'max': 


    ### Automatismo ###
    print(' ')
    print('(Es un problema de tipo maximizar)')
    print(' ')
    nuart=nart
    if (nart > 0):               # Si ocurre esto, entramos en la fase I donde se resuelve un problema de tipo minimizar
        mnm = min(ccbar.list())
        if mnm==0:
            if w>0:
                show(Cuadro)
                print('El problema original no tiene soluciones factibles')
            else:
                show(Cuadro)
                print('El problema de la fase I es óptimo y Wopt=0. Por tanto, el original es factible')
                print('Preparemos el cuadro inicial de la fase II')
                if (nuart == 0):
                    faseII(nuart,tt)   # y se resuelve el problema que es de tipo maximizar
                    show(Cuadro)
                    mnm = max(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm > 0:
                            ve=cbar.list().index(max(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=max(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
                else:
                    for i in range(m):         #sacamos de la base las artificiales que "buenamente" se puedan
                        if (tt[i]==1):
                            for j in range(n):
                                if (A[i,j] != 0):
                                    cambioA(i+1,j+1)
                                    nuart=nuart-1
                                    tt[i]=0
                    faseII(nuart,tt)
                    show(Cuadro)
                    mnm = max(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm > 0:
                            ve=cbar.list().index(max(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=max(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
        else:        
            while mnm < 0:
                ve=ccbar[0,[0..(nvar-1)]].list().index(min(ccbar[0,[0..(nvar-1)]].list()))
                vs=cocientesA(ve+1) 
                print('cambio(',vs+1,',',ve+1,')')
                cambioA(vs+1,ve+1)
                if (tt[vs]==1):             #si la variable de salida es artificial, restamos uno a nuart.
                    nuart=nuart-1
                    tt[vs]=0       # porque tt(j)=1 indica que estamos usando la variable articicial j-ésima.
                mnm=min(ccbar[0,[0..(nvar-1)]].list())
            if (w>0):
                show(Cuadro)
                print('El problema original no tiene soluciones factibles')
            else:
                show(Cuadro)
                print('El problema de la fase I es óptimo y Wopt=0. Por tanto, el original es factible')
                print('Preparemos el cuadro inicial de la fase II')
                if (nuart == 0):
                    faseII(nuart,tt)   # y se resuelve el problema que es de tipo maximizar
                    show(Cuadro)
                    mnm = max(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm > 0:
                            ve=cbar.list().index(max(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=max(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
                else:
                    for i in range(m):         #sacamos de la base las artificiales que "buenamente" se puedan
                        if (tt[i]==1):
                            for j in range(n):
                                if (A[i,j] != 0):
                                    cambioA(i+1,j+1)
                                    nuart=nuart-1
                                    tt[i]=0
                    show(Cuadro)
                    faseII(nuart,tt)
                    mnm = max(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm > 0:
                            ve=cbar.list().index(max(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=max(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
    else:   #Podemos aplicar el símplex sin variables artificiales
        mnm = max(cbar.list())
        if (mnm==0):
            print('El problema es óptimo')
        else:
            while mnm > 0:
                ve=cbar.list().index(max(cbar.list()))
                vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                if vs== -1:
                    show(Cuadro)
                    print('El problema es no acotado')
                    mnm= 0
                else: 
                    print('cambio(',vs+1,',',ve+1,')')
                    cambioA(vs+1,ve+1)
                    mnm=max(cbar.list())
                    if (mnm==0):
                        show(Cuadro)
                        print('El problema es óptimo')

else: 
    ### Automatismo ###
    print(' ')
    print('(Es un problema de tipo minimizar)')
    print(' ')
    nuart=nart
    if (nart > 0):               # Si ocurre esto, entramos en la fase I donde se resuelve un problema de tipo minimizar
        mnm = min(ccbar.list())
        if mnm==0:
            if w>0:
                show(Cuadro)
                print('El problema original no tiene soluciones factibles')
            else:
                show(Cuadro)
                print('El problema de la fase I es óptimo y Wopt=0. Por tanto, el original es factible')
                print('Preparemos el cuadro inicial de la fase II')
                if (nuart == 0):
                    faseII(nuart,tt)   # y se resuelve el problema que es de tipo minimizar
                    show(Cuadro)
                    mnm = min(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm < 0:
                            ve=cbar.list().index(min(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=min(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
                else:
                    for i in range(m):         #sacamos de la base las artificiales que "buenamente" se puedan
                        if (tt[i]==1):
                            for j in range(n):
                                 if (A[i,j] != 0):
                                     cambioA(i+1,j+1)
                                     nuart=nuart-1
                                     tt[i]=0
                    faseII(nuart,tt)
                    show(Cuadro)
                    mnm = min(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm < 0:
                            ve=cbar.list().index(min(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=min(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
        else:        
            while mnm < 0:
                ve=ccbar[0,[0..(nvar-1)]].list().index(min(ccbar[0,[0..(nvar-1)]].list()))
                vs=cocientesA(ve+1) 
                print('cambio(',vs+1,',',ve+1,')')
                cambioA(vs+1,ve+1)
                if (tt[vs]==1):             #si la variable de salida es artificial, restamos uno a nuart.
                    nuart=nuart-1
                    tt[vs]=0       # porque tt(j)=1 indica que estamos usando la variable articicial j-ésima.
                mnm=min(ccbar[0,[0..(nvar-1)]].list())
            if (w>0):
                show(Cuadro)
                print('El problema original no tiene soluciones factibles')
            else:
                show(Cuadro)
                print('El problema de la fase I es óptimo y Wopt=0. Por tanto, el original es factible')
                print('Preparemos el cuadro inicial de la fase II')
                if (nuart == 0):
                    faseII(nuart,tt)   # y se resuelve el problema que es de tipo minimizar
                    show(Cuadro)
                    mnm = min(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm < 0:
                            ve=cbar.list().index(min(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=min(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
                else:
                    for i in range(m):         #sacamos de la base las artificiales que "buenamente" se puedan
                        if (tt[i]==1):
                            for j in range(n):
                                if (A[i,j] != 0):
                                    cambioA(i+1,j+1)
                                    nuart=nuart-1
                                    tt[i]=0
                    faseII(nuart,tt)
                    show(Cuadro)
                    mnm = min(cbar.list())
                    if (mnm==0):
                        print('El problema es óptimo')
                    else:
                        while mnm < 0:
                            ve=cbar.list().index(min(cbar.list()))
                            vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                            if vs== -1:
                                show(Cuadro)
                                print('El problema es no acotado')
                                mnm= 0
                            else: 
                                print('cambio(',vs+1,',',ve+1,')')
                                cambioA(vs+1,ve+1)
                                mnm=min(cbar.list())
                                if (mnm==0):
                                    show(Cuadro)
                                    print('El problema es óptimo')
    else:    #Podemos aplicar el símplex sin variables artificiales
        mnm = min(cbar.list())
        if (mnm==0):
            print('El problema es óptimo')
        else:
            while mnm < 0:
                ve=cbar.list().index(min(cbar.list()))
                vs=cocientesA(ve+1) # Ojo, este comando no coincide con el habitual
                if vs== -1:
                    show(Cuadro)
                    print('El problema es no acotado')
                    mnm= 0
                else: 
                    print('cambio(',vs+1,',',ve+1,')')
                    cambioA(vs+1,ve+1)
                    mnm=min(cbar.list())
                    if (mnm==0):
                        show(Cuadro)
                        print('El problema es óptimo')
